//+------------------------------------------------------------------+
//|                                                    DailyData.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Maroon
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern color zoneColor      = C'30,33,36';
extern color normalColor    = LimeGreen;
extern color changeColor    = PaleVioletRed;
extern color negativeColor  = Red;
extern color positiveColor  = Gold;
extern color textColor      = DimGray;
extern int   CandleShift    = 8;
extern int   VerticalShift  = 15;
extern bool  ShowInfo       = True;
extern bool  ShowSwap       = True;
extern bool  ShowBackground = True;
extern bool  ShowBar        = True;
extern string TimeFrame = "";

//
//
//
//
//

double DayHigh[];
double DayLow[];
double DayOpen[];
double DayClose[];
double prevCurr =-1;
int    DataPeriod;
int    DataBar;
string indNames = "DailyData";
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0, DayHigh);
   SetIndexBuffer(1, DayLow);
   SetIndexBuffer(2, DayClose);
   SetIndexBuffer(3, DayOpen);
      if (ShowBar)
         for (int i=0;i<4;i++)
            {
               SetIndexStyle(i,DRAW_HISTOGRAM);
               SetIndexShift(i,CandleShift);
               SetIndexLabel(i,NULL);
            }            
      else  for (i=0;i<4;i++) SetIndexStyle(i,DRAW_NONE);

   //
   //
   //
   //
   //
   
   if (TimeFrame=="")
      switch(Period())
      {
         case PERIOD_MN1:
         case PERIOD_W1:  DataPeriod = PERIOD_MN1; break;
         case PERIOD_D1:  DataPeriod = PERIOD_W1;  break;
         default:         DataPeriod = PERIOD_D1;
      }
   else  DataPeriod = stringToTimeFrame(TimeFrame);      
   prevCurr = -1;
   return(0);
}
int deinit()
{
   for (int counter=-1;counter<19;counter++) ObjectDelete(indNames+counter);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   string symbol   = Symbol();
                if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);

   int    digits   = MarketInfo(symbol,MODE_DIGITS);
   double modifier = 1;
   
      if (digits==3 || digits==5) modifier = 10.0;
      else 
            if (ObjectFind(indNames+"16") != -1)
                ObjectDelete(indNames+"16");
      
      //
      //
      //
      //
      //
            
      DataBar  = iBarShift(symbol,DataPeriod,Time[0]);
         double HiDAILY  = iHigh (symbol,DataPeriod,DataBar);
         double LoDAILY  = iLow  (symbol,DataPeriod,DataBar); 
         double current  = iClose(symbol,DataPeriod,DataBar);
         double range    = getRange(DataPeriod,symbol)/modifier;
         double change   = (current-iOpen(symbol,DataPeriod,DataBar))/(MarketInfo(symbol,MODE_POINT)*modifier);
         int    limit,i;
      
      //
      //
      //
      //
      //

      if (ShowInfo)
      {
          if (ObjectFind(indNames+"1") ==-1) {
                  objectCreate("1",10,VerticalShift+10,"-------------------------------------------",10,NULL);  
                  objectCreate("3",60,VerticalShift+32,"distance from high : ");
                  objectCreate("4",60,VerticalShift+44,"distance from low : " );
                  objectCreate("5",60,VerticalShift+56,"spread : " );
                  objectCreate("6",10,VerticalShift+68,"-------------------------------------------",10,NULL);
                     if (ShowSwap)
                     {
                        objectCreate("2",60,VerticalShift+20,"change/range : ");
                        objectCreate("7",60,VerticalShift+76,"swap long : "         );
                        objectCreate("8",60,VerticalShift+88,"swap short : "        );
                        objectCreate("9",10,VerticalShift+96,"-------------------------------------------",10,NULL);  
                     }
                     else
                     {
                        objectCreate("2",60,VerticalShift+20,"range : "       );
                        objectCreate("7",60,VerticalShift+76,"distance from open : ");
                        objectCreate("9",10,VerticalShift+88,"-------------------------------------------",10,NULL);  
                     }                     
         }

         //
         //
         //
         //
         //

         if (prevCurr != current)
            {
               prevCurr = current;
                  double currFromHi = (HiDAILY-current)/(MarketInfo(symbol,MODE_POINT)*modifier);
                  double currFromLo = (current-LoDAILY)/(MarketInfo(symbol,MODE_POINT)*modifier);

                  //
                  //
                  //
                  //
                  //
                  
                     objectCreate("0",128,VerticalShift+0,symbol,10,"Arial bold",normalColor);  
                     if (ShowSwap)
                           objectCreate("11",10,VerticalShift+20,DoubleToStr(change,0)+"/"+DoubleToStr(range,0)  ,10,"Arial bold",changeColor);
                     else  objectCreate("11",10,VerticalShift+20,                          DoubleToStr(range,0)  ,10,"Arial bold",changeColor);
                     objectCreate("12",10,VerticalShift+32,DoubleToStr(currFromHi,0)                             ,10,"Arial bold",normalColor);
                     objectCreate("13",10,VerticalShift+44,DoubleToStr(currFromLo,0)                             ,10,"Arial bold",normalColor);
                     objectCreate("14",10,VerticalShift+56,DoubleToStr(MarketInfo(symbol,MODE_SPREAD)/modifier,2),10,"Arial bold",normalColor);
                     if (ShowSwap)
                     {
                        objectCreate("15",10,VerticalShift+76,DoubleToStr(MarketInfo(symbol,MODE_SWAPLONG),2) ,10,"Arial bold",normalColor);
                        objectCreate("16",10,VerticalShift+88,DoubleToStr(MarketInfo(symbol,MODE_SWAPSHORT),2),10,"Arial bold",normalColor);
                     }
                     else
                     {
                        if (change<0)
                              objectCreate("15",10,VerticalShift+76,DoubleToStr(change,0) ,10,"Arial bold",negativeColor);
                        else  objectCreate("15",10,VerticalShift+76,DoubleToStr(change,0) ,10,"Arial bold",positiveColor);
                     }
                  string currentValue = DoubleToStr(current,digits);                  
                     objectCreate("17",10, VerticalShift+0,currentValue,12,"Arial bold",normalColor);  
                     if (modifier !=1)
                        objectCreate("18",10,VerticalShift+0,StringSubstr(currentValue,StringLen(currentValue)-1),12,"Arial bold",textColor);  
            }   
      }           
      setBarIndicator(change,HiDAILY,LoDAILY,iOpen(symbol,DataPeriod,DataBar),current);
      for(i=0,limit=Bars-1;i<4;i++) SetIndexDrawBegin(i,limit); 
   return(0);
  }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+  
//
//
//
//
//

void setBarIndicator(double change, double hi,double low, double open, double close)
{
   string name  = indNames+"-1";
   int    shift = 0;
   
   if (change>0) { DayHigh[shift]  = hi;  DayLow[shift] = low; }            
   else          { DayHigh[shift]  = low; DayLow[shift] = hi;  }            
                   DayOpen[shift]  = open;
                   DayClose[shift] = close;

   if (ShowBackground)
      {                         
         if (ObjectFind(name) == -1)
             ObjectCreate(name,OBJ_RECTANGLE,0,0,0);
             ObjectSet(name,OBJPROP_TIME1,iTime(NULL,DataPeriod,DataBar));
             ObjectSet(name,OBJPROP_TIME2,iTime(NULL,         0,0));
             ObjectSet(name,OBJPROP_PRICE1,hi);
             ObjectSet(name,OBJPROP_PRICE2,low);
             ObjectSet(name,OBJPROP_COLOR,zoneColor);
      }             
}

//
//
//
//
//

double getRange(int period, string symbol)
{
      double range = iHigh(symbol, period, DataBar) - iLow(symbol, period, DataBar);
      return (NormalizeDouble(range/MarketInfo(symbol,MODE_POINT),0));
}

//
//
//
//
//

void objectCreate(string name,int x,int y,string text="-",int size=10,
                  string font="Arial",color colour=-1,int window = 0)
{
   if (colour==-1) colour=textColor;
   if (ObjectFind(indNames+name) == -1)
   {
      ObjectCreate(indNames+name,OBJ_LABEL,window,0,0);
         ObjectSet(indNames+name,OBJPROP_CORNER,1);
         ObjectSet(indNames+name,OBJPROP_XDISTANCE,x);
         ObjectSet(indNames+name,OBJPROP_YDISTANCE,y);
   }               
   ObjectSetText(indNames+name,text,size,font,colour);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}